/*---------------------------------------------------*
 |      FPrecendent.java                             |
 |---------------------------------------------------|
 | Ce fichier dfinit le filtre FPrecendent qui      |
 | aprs une fusion, de revenir en arrire dans la   |
 | hirarchie.                                       |
 *---------------------------------------------------*/

// Dsignation du package d'appartenance
package photoshed.filtres;

// Importations des librairies JAVA ncssaires
import java.awt.image.BufferedImage;
import java.awt.Component;
import javax.swing.JFrame;
import photoshed.fenetres.Picture;
import photoshed.filtres.Filter;
import photoshed.filtres.fusion.FInfos;
import photoshed.filtres.watershed.WS;

// Dbut de la classe FPrecedent
public final class FPrecedent implements Filter
{
	// ----- Dclaration des attributs de Fusion
	private JFrame fenetre;
	private boolean firstTime = true;

	// ----- Mthodes d'instances

	// Fonction indiquant au programme principal si l'objet que l'on veut traiter peut l'tre
	public boolean isApplicable(Picture pic)
	{
		if (pic.property instanceof FInfos)
			if (((FInfos) pic.property).precedent != null)
				return true;
		return false;
	}

	// Fonction qui renvera un objet Picture dj existant qui reprsente l'image prcdente dans la hirarchie de fusion
	public Picture execute(Picture pic)
	{
		// Rcupration de la JFrame principal de l'application
		if (this.firstTime)
		{
			Component cmp = pic.getDesktopPane();
			while(!(cmp instanceof JFrame))
				cmp = cmp.getParent();
			this.fenetre = (JFrame) cmp;
			this.firstTime = false;
		}

		// Traitement de la fusion
		if (pic == null)
			return null;

		FInfos infos = (FInfos) pic.property;
		try
		{
			infos.precedent.setVisible(true);
			infos.precedent.toFront();
			infos.precedent.setSelected(true);			
		}
		catch (java.beans.PropertyVetoException e)
		{
		}
		return null;
	}

	// Fonction qui ne sert  rien
	public BufferedImage traitement(BufferedImage src, BufferedImage dst)
	{
		return null;
	}

	// Fonction toString de la Classe
	public String toString()
	{
		return "Retour en arrire";
	}
}
// Fin de la classe FPrecedent